'''
Created on 2014-11-20

@author: Administrator
'''
import random 
import sys,os,time
from optparse import OptionParser 
from tempfile import gettempdir
try:
    import numpy
except ImportError:
    print >>sys.stderr, "No numpy module"
genotype=['00','01','10','11']
allele=[0,1]
def random_allele(segsites):
    pvalue=random.uniform(0,1)
    sampleallele=numpy.random.choice(allele,segsites,replace=True,p=[pvalue,1-pvalue])
    return sampleallele

def back_population(background,segsites):
    tracj0=[]
    for j in range(background):
        tracj0.append(random_allele(segsites))
    return tracj0
    

def fit(S):
    fitness={}
    fitness.setdefault('00',{})['00']=1
    fitness.setdefault('00',{})['01']=1*(1+S[1])
    fitness.setdefault('00',{})['10']=(1+S[0])*1
    fitness.setdefault('00',{})['11']=(1+S[0])*(1+S[1])
    fitness.setdefault('01',{})['00']=1*(1+S[1])
    fitness.setdefault('01',{})['01']=1*(1+2*S[1])
    fitness.setdefault('01',{})['10']=(1+S[0])*(1+S[1])
    fitness.setdefault('01',{})['11']=(1+S[0])*(1+2*S[1])
    fitness.setdefault('10',{})['00']=(1+S[0])*1
    fitness.setdefault('10',{})['01']=(1+S[0])*(1+S[1])
    fitness.setdefault('10',{})['10']=(1+2*S[0])*1
    fitness.setdefault('10',{})['11']=(1+2*S[0])*(1+S[1])
    fitness.setdefault('11',{})['00']=(1+S[0])*(1+S[1])
    fitness.setdefault('11',{})['01']=(1+S[0])*(1+2*S[1])
    fitness.setdefault('11',{})['10']=(1+2*S[0])*(1+S[1])
    fitness.setdefault('11',{})['11']=(1+2*S[0])*(1+2*S[1])
    return fitness

def off_fre(fitness,r,D,x1,x2,x3,x4):
    w1=x1*fitness['00']['00']+x2*fitness['00']['01']+x3*fitness['00']['10']+x4*fitness['00']['11']
    w2=x1*fitness['01']['00']+x2*fitness['01']['01']+x3*fitness['01']['10']+x4*fitness['01']['11']
    w3=x1*fitness['10']['00']+x2*fitness['10']['01']+x3*fitness['10']['10']+x4*fitness['10']['11']
    w4=x1*fitness['11']['00']+x2*fitness['11']['01']+x3*fitness['11']['10']+x4*fitness['11']['11']
    w=x1*w1+x2*w2+x3*w3+x4*w4
    x1_new=x1*(w1/w)-r*D*(fitness['00']['11']/w)
    x2_new=x2*(w2/w)+r*D*(fitness['00']['11']/w)
    x3_new=x3*(w3/w)+r*D*(fitness['00']['11']/w)
    x4_new=x4*(w4/w)-r*D*(fitness['00']['11']/w)
    return x1_new,x2_new,x3_new,x4_new    
def parent_type(tracj0,p1,p2):
    sample00=[]
    sample01=[]
    sample10=[]
    sample11=[]
    for ele in tracj0:
        standard=str(ele[p1])+str(ele[p2])
        if standard=='00':
            sample00.append(ele)
        elif standard=='01':
            sample01.append(ele)
        elif standard=='10':
            sample10.append(ele)
        else:
            sample11.append(ele)
    return sample00, sample01, sample10, sample11

def simulation(generation,tracj0,fitness,r,nsam,segsites,p1,p2):
    for i in range(generation):
        tracj=[]
        (sample00,sample01,sample10,sample11)=parent_type(tracj0,p1,p2)
        x1=len(sample00)/float(len(tracj0))
        x2=len(sample01)/float(len(tracj0))
        x3=len(sample10)/float(len(tracj0))
        x4=len(sample11)/float(len(tracj0))
        D=x1*x4-x2*x3
        (x1,x2,x3,x4)=off_fre(fitness,r,D,x1,x2,x3,x4)
        D=x1*x4-x2*x3
        phase=numpy.random.choice(genotype,nsam,p=[x1,x2,x3,x4])
        for j in range(len(phase)):
            if phase[j]=='00':
                if len(sample00)==0:
                    sampleallele=random_allele(segsites)
                    sampleallele[p1]=int(phase[j][0])
                    sampleallele[p2]=int(phase[j][1])
                else:
                    sampleallele=random.sample(sample00,1)[0]
            elif phase[j]=='01':
                if len(sample01)==0:
                    sampleallele=random_allele(segsites)
                    sampleallele[p1]=int(phase[j][0])
                    sampleallele[p2]=int(phase[j][1])
                else:
                    sampleallele=random.sample(sample01,1)[0]
            elif phase[j]=='10':
                if len(sample10)==0:
                    sampleallele=random_allele(segsites)
                    sampleallele[p1]=int(phase[j][0])
                    sampleallele[p2]=int(phase[j][1])
                else:
                    sampleallele=random.sample(sample10,1)[0]
            else:
                if len(sample11)==0:
                    sampleallele=random_allele(segsites)
                    sampleallele[p1]=int(phase[j][0])
                    sampleallele[p2]=int(phase[j][1])
                else:
                    sampleallele=random.sample(sample11,1)[0]
            tracj.append(sampleallele)
        tracj0.append(sampleallele)
    return tracj

    

def main():
    usage = "usage: python %prog <-n sample_number> <-r replication_number> [...]"
    description = "two-SNPs locus evolution simulation of neutral and selection model. For example: python %prog -p 0.8 0.05 0.05 0.1"
    op = OptionParser(version="%prog 0.1",description=description,usage=usage,add_help_option=False)
    op.add_option("-h","--help",action="help",
                  help="Show this help message and exit.")
    op.add_option("-n","--sample_number",dest="nsam",type="int",default="30",
                  help=" please input the number of simulated samples, default is 30 samples")
    op.add_option("-r","--replication_number",dest="nrep",type="int", default="1",
                  help=" please input the replication number of simulated samples, default is 1")
    op.add_option("-l","--region_length",dest="region",type="int", default="100000",
                  help="please input the length of simulated region (kb), default is 100kb")
    op.add_option("-g","--generation",dest="generation",type="int", default="30",
                  help="please input the number of simulated generation,default is 30")
    op.add_option("-t","--two_locus",dest="two_locus",type="int", nargs=2,
                  help="please input the position of selected two_locus,seprated by space. It would be random selected if not specified ")
    op.add_option("-p","--haplotype_frequency",dest="haplotype",type="float", nargs=4,
                  help="please input the frequency of haplotype of selected two_locus seprated by space. It followed the order 00, 01, 10 and 11 which 0 represented ancestor and 1 represented derived , the sum should be 1")
    op.add_option("-R","--recombination_rate",dest="R",type="float", default="0.5",
                  help="please input the recombination rate per site,defaule is 0.5 not linkage")
    op.add_option("-s","--selection_coefficient",dest="s",type="float", nargs=2,
                  help="please input the select advatage of derived allele,seprated by spece, default is neutral model which is 0, 0 respectively ")
    op.add_option("-e","--segsites",dest="segsites",type="int",
                  help="please input the number of segsites in the region, it would be randomly generated according to the length of region if not input ")
    op.add_option("-o","--outfilename",dest="outfilename",type="str",default="simulation.out",
                  help="The file name of output file showing the simulation data including number of segsites, position of each segsite, positions of selected two-locus, allele of each sample")
    (options,args) = op.parse_args()
    

    if not options.haplotype:
        op.print_help()
        sys.exit(1)
    if not options.s:
        S=[0,0]
    else:
        s=list(options.s)
    haplotype=list(options.haplotype)
    nrep=options.nrep
    nsam = options.nsam
    region=range(0,options.region)
    if not options.segsites:
        segsites = numpy.random.poisson(len(region)/100, 1)[0]
    else:
        segsites = options.segsites
    generation=options.generation
    if float('%.4f'%sum(haplotype)) != 1:
        print "The sum of haplotype frequency is not equal 1!"
        sys.exit(1)
    r=options.R
    outputfilename=options.outfilename
    if os.path.exists(outputfilename):
        os.remove(outputfilename)
    if nsam >=100000:
        background = nsam
    else:
        background = 100000
    #-----------step 1: random generate initial population-----------
    print "Generate the initial population"
    tracj0=back_population(background,segsites)
    fitness=fit(S)
    #-----------step 2: simulation offspring ----------------
    print "Simulation the offspring"
    for n in range(nrep):
        print "simulation the "+str(n)+"th replication"
        position=sorted(random.sample(region,segsites))
        if not options.two_locus:
            if segsites == 2:
                two_locus = position
            else:
                two_locus=sorted(random.sample(position,2))    
        else:
            two_locus=list(options.two_locus)
            if segsites == 2:
                position=[]
                for ele in two_locus:
                    position.append(int(ele))
        for i in range(len(two_locus)):
            distance=[]
            for ele in position:
                distance.append(abs(ele-int(two_locus[i])))
                rankdistance=sorted(distance)
            two_locus[i]=position[distance.index(rankdistance[0])] 
        p1=position.index(two_locus[0])
        p2=position.index(two_locus[1])
        phase=numpy.random.choice(genotype,background,p=haplotype)
        for i in range(len(tracj0)):
            tracj0[i][p1]=int(phase[i][0])
            tracj0[i][p2]=int(phase[i][1])  
        tracj=simulation(generation,tracj0,fitness,r,nsam,segsites,p1,p2)
        res=open(os.path.join(os.getcwd(),outputfilename),'wb')
        print >> res,"//"
        print >> res,'Segsites'+':'+' '+str(segsites)
        positionout=''
        for ele in position:
            positionout=positionout+str(ele)+'\t'
        print >> res,'Positions'+':'+' '+positionout
        print >> res,"Selected two locus:"+' '+str(two_locus[0])+'\t'+str(two_locus[1])
        for ele in tracj:
            samout=''
            for alle in ele:
                samout=samout+str(alle)
            print >> res,samout
    print " A region of "+str(options.region)+'bp include '+str(segsites)+" was simulated for "+str(generation)+' generations with population size '+str(nsam)+' for '+str(nrep)+' replication.'

           

if __name__ == "__main__":
    
    try:
        main()
    except KeyboardInterrupt:
        sys.stderr.write("User interrupt me, see you!\n")
        sys.exit(0)    

            
                    
    



     
